//Zylinder-Abschnitt (Nullpkt. Basis Zylinder)
//Endversion 1

//Position Zylinderboden-Mitte entspricht (0,-16.5,0) in cm

//KOMMENTARE:
//So uebersichtlicher, ausserdem Moeglichkeit beim Picken direkt Drehen ohne Translation

import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.image.TextureLoader;

import java.net.URL;
import java.net.MalformedURLException;

public class CylinderSection extends SharedGroup {

    public CylinderSection(java.awt.Component observer, TurnButton turnButton, URL context) {
        super();

        //Allgemein
        Vector3f vec = new Vector3f();
        Transform3D trafo = new Transform3D();
       
        //TurnButton
        vec.set(0.0f,23.5f,0.0f);
        trafo.setTranslation(vec);//Unterschied in Hhe Boden Zylinder Boden Drehknopf ist 39.5 cm
        TransformGroup tg1 = new TransformGroup(trafo);
        tg1.addChild(new Link(turnButton));
        this.addChild(tg1);

        //Achse
        Cylinder axis = new Cylinder(1.0f,40.0f, AppData.brown2A);//Obwohl 6cm der 40 cm hohen Achse nicht sichtbar sind
       
        axis.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);

        vec.set(0.0f,3.0f,0.0f);
        trafo.setTranslation(vec);
        TransformGroup tg2 = new TransformGroup(trafo);
        tg2.addChild(axis);
        this.addChild(tg2);
     
        //Cylinder
        Cylinder cylinder = new Cylinder(3.0f, 33.0f, Cylinder.GENERATE_TEXTURE_COORDS | Cylinder.GENERATE_NORMALS, AppData.whiteA);

        Appearance app = new Appearance();
        app.setMaterial(MaterialData.whiteM);
       
	try {
		URL url = new URL(context, "textures/wsneper.jpg");
                TextureLoader tex = new TextureLoader(url, observer);
                app.setTexture(tex.getTexture());
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }       
       
        cylinder.getShape(Cylinder.BODY).setAppearance(app);
       
        cylinder.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        cylinder.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        cylinder.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
       
        //NEU (Wegen Textur, oder Textur aendern (schwierig), TODO ACHSE ALS MITTELPUNKT UND DATEN AENDERN!)
        trafo.rotY(-2 * Math.PI / 66);//72
        TransformGroup tg3 = new TransformGroup(trafo);
        tg3.addChild(cylinder);
        this.addChild(tg3);
    }
}
