//PickTurnCalculator:
//Verhalten, das genau auf das Addierwerk der Rechenmaschine eingestellt ist:
//Es ist nur moeglich auf die 6 Hauptzahnraedereinheiten zu klicken, die dann jeweils um eins weiterschalten (add./sub.),
//waehrenddessen sich u.U. die 5 Uebergangszahnraedereinheiten mitdrehen.

//Vor.: WRITE/READ-ABLE muss klar sein
//Und ohne TRANSLATION. ES MUSS EXTRA TRANSLATIONSKNOTEN EXISTIEREN
//NUR DIESES BEHAVIOR AENDERT AN UEBERGEBENEN TRANSF.KNOTEN WAS!!! Akt. Transformation wird nicht eingelesen, currTrans,... immer aktuell!
//Zu Beginn Identitaet!!!!!!

//Version D

//Jetzt mit Endcheck! Cursoraenderung! 2.Taste! TEXTAREA! (WEGEN FEHLERMELDUNG!)

//KOMMENTARE:
//Kein Analogon zu MouseRotateY->PickRotateY, sondern total neue Klasse
//Damit Callback, kann z.B. transformChanged ueberschrieben werden
//Weiterdrehen bei druecken geht nicht, ist aber unnoetig!
//Invert und flag alles weg!

//TODO: Kommentare weg oder verenglischen, BESSERER NAME, CheckID auf 1 Feld verkuerzen? Was wenn 6-Uebertrag, bzw. 0-Untertrag!

import com.sun.j3d.utils.behaviors.picking.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class PickTurnCalculator extends Behavior implements Runnable {
   
  private TransformGroup[] currGrp = new TransformGroup[6];
  private Transform3D[] currTrans = new Transform3D[6];
  private TransformGroup[] middleGrp = new TransformGroup[5];
  private Transform3D[] middleTrans = new Transform3D[5];

  private PickObject pickScene;   
  private WakeupCriterion wakeupAWT;
  private int pickMode = PickObject.USE_BOUNDS;
   
  protected double overall_angle;
  protected long duration;

  private Transform3D dRotateY;
  private Transform3D dMRotateY;

  protected boolean active = false;
  private boolean rightPress = false;

  private String testString;
  private int value[]={0,0,0,0,0,0};

  private WakeupCriterion wakeUpTemp;
  private AWTEvent[] evtTemp;
  private MouseEvent mEventTemp;
  private SceneGraphPath pathTemp = new SceneGraphPath();
  private int endCTemp=0;
  private int beginCTemp=0;
  private int endMTemp=0;
  private int beginMTemp=0;
  private Object objTemp=null;
   
  private Canvas3D canvas;
  private TextArea textArea;
   
  private Sound sound;
  private boolean soundSet=false;
   
  public PickTurnCalculator(BranchGroup root, Canvas3D canvas, Bounds bounds, TransformGroup[] turnTG, TransformGroup[] middleTG,
   		            String currId, TextArea textArea) {
    super();
    pickScene = new PickObject(canvas, root);
     
    currGrp = turnTG;
    middleGrp = middleTG;
     
    for(int i=0; i < 6; i++) {
     currTrans[i] = new Transform3D();
    }     
    for(int i=0; i < 5; i++) {
     middleTrans[i] = new Transform3D();
    }     
   
    duration = 10000;
    overall_angle = Math.PI / 2.0d;
    dRotateY = new Transform3D();
    dRotateY.rotY(Math.PI /2.0d / 10000.0d);
    dMRotateY = new Transform3D();
    dMRotateY.rotY(-Math.PI /2.0d / 10000.0d);

    this.setSchedulingBounds(bounds);
    testString = currId;
     
    this.canvas = canvas;
    this.textArea = textArea;
  }

  public PickTurnCalculator(BranchGroup root, Canvas3D canvas, Bounds bounds, TransformGroup[] turnTG, TransformGroup[] middleTG,
		     String currId, long new_duration, double new_angle, TextArea textArea){
    super();
    pickScene = new PickObject(canvas, root);
     
    currGrp = turnTG;
    middleGrp = middleTG;
     
    for(int i=0; i < 6; i++) {
     currTrans[i] = new Transform3D();
    }
    for(int i=0; i < 5; i++) {
     middleTrans[i] = new Transform3D();
    }     

    duration = new_duration;
    overall_angle = new_angle;
    dRotateY = new Transform3D();
    dRotateY.rotY(overall_angle / ((double) duration));
    dMRotateY = new Transform3D();
    dMRotateY.rotY(-overall_angle / ((double) duration));

    this.setSchedulingBounds(bounds);
    testString = currId;
     
    this.canvas = canvas;
    this.textArea = textArea;
  }
   
  public PickTurnCalculator(BranchGroup root, Canvas3D canvas, Bounds bounds, TransformGroup[] turnTG, TransformGroup[] middleTG,
		            String currId, int pickMode, TextArea textArea){
    super();
    pickScene = new PickObject(canvas, root);
     
    currGrp = turnTG;
    middleGrp = middleTG;
     
    for(int i=0; i < 6; i++) {
     currTrans[i] = new Transform3D();
    }
    for(int i=0; i < 5; i++) {
     middleTrans[i] = new Transform3D();
    }     

    duration = 10000;
    overall_angle = Math.PI / 2.0d;
    dRotateY = new Transform3D();
    dRotateY.rotY(Math.PI /2.0d / 10000.0d);
    dMRotateY = new Transform3D();
    dMRotateY.rotY(-Math.PI /2.0d / 10000.0d);

    this.setSchedulingBounds(bounds);
    this.pickMode = pickMode;
    testString = currId;
     
    this.canvas = canvas;
    this.textArea = textArea;
  }
   
  public PickTurnCalculator(BranchGroup root, Canvas3D canvas, Bounds bounds, TransformGroup[] turnTG, TransformGroup[] middleTG,
		            String currId, long new_duration, double new_angle, int pickMode, TextArea textArea){
    super();
    pickScene = new PickObject(canvas, root);
     
    currGrp = turnTG;
    middleGrp = middleTG;

    for(int i=0; i < 6; i++) {
     currTrans[i] = new Transform3D();
    }
    for(int i=0; i < 5; i++) {
     middleTrans[i] = new Transform3D();
    }     

    duration = new_duration;
    overall_angle = new_angle;
    dRotateY = new Transform3D();
    dRotateY.rotY(overall_angle / ((double) duration));
    dMRotateY = new Transform3D();
    dMRotateY.rotY(-overall_angle / ((double) duration));
     
    this.setSchedulingBounds(bounds);   
    this.pickMode = pickMode;
    testString = currId;
     
    this.canvas = canvas;
    this.textArea = textArea;
  }

  public void setReset(Transform3D identity) {
   for (int i=0; i<6; i++) {
      currTrans[i].set(identity);
      currGrp[i].setTransform(currTrans[i]);
      value[i] = 0;
   }
    
   for (int i=0; i<5; i++) {
      middleTrans[i].set(identity);
      middleGrp[i].setTransform(middleTrans[i]);
   }
  }

   
  public void setSound(Sound sound) {   
   if (sound != null) {
     this.sound = sound;
     soundSet = true;
   } 
  }   
   
  public void setPickMode(int pickMode) {
    this.pickMode = pickMode;
  }

  public int getPickMode() {
    return pickMode;
  }

  public boolean isActive() {
   return active;
  }
   
  public long getDuration() {
    return duration;
  }
  
  public void setDuration( long new_duration ) {
   if (!active)
     duration = new_duration;
  }
   
  public double getOverallAngle() {
   return overall_angle;
  }
 
  public void setOverallAngle( double new_overall_angle ) {
   if (!active)
       {
        overall_angle = new_overall_angle;
        dRotateY = new Transform3D();
        dRotateY.rotY(overall_angle / ((double) duration));
        dMRotateY = new Transform3D();
        dMRotateY.rotY(-overall_angle / ((double) duration));	  
       }
  }    
   
  public void initialize() {
    wakeupAWT = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);
    wakeupOn (wakeupAWT);
  }

  public void processStimulus (Enumeration criteria) {
   if (!active) {
     
    while(criteria.hasMoreElements()) {
     wakeUpTemp = (WakeupCriterion)criteria.nextElement();
       
     if (wakeUpTemp instanceof WakeupOnAWTEvent)
       evtTemp = ((WakeupOnAWTEvent)wakeUpTemp).getAWTEvent();
    }
        
    if (evtTemp[0] instanceof MouseEvent) {//also Maustaste gedrueckt
      mEventTemp = (MouseEvent) evtTemp[0];
	  
      if (!mEventTemp.isAltDown()) {
        pathTemp = pickScene.pickClosest(mEventTemp.getPoint().x, mEventTemp.getPoint().y, pickMode);

        //GetNode beginnt bei 0 ganz oben!!!!!
        if (pathTemp != null) {
            for (int i = 0; i < pathTemp.nodeCount(); i++) {
	       objTemp = pathTemp.getNode(i).getUserData();
	       if (objTemp instanceof CheckID) {
		 if (((CheckID) objTemp).getID1() == testString) {//TODO: Unnoetig, da CheckID schon speziell genug?
                   active = true;
	           canvas.setCursor(SceneViewer3D.hand_cursor);
		    
		   beginCTemp = ((CheckID) objTemp).getID2();//immer von rechts nach links!

		   if (!mEventTemp.isMetaDown()) {//LINKE TASTE
     
		       //Bestimmung von endCtemp und Addition
	               for (endCTemp = beginCTemp; endCTemp < 6; endCTemp++) {
		          if (value[endCTemp] < 9) {
		            value[endCTemp] ++;
		            break;
		          }
		         else
		            value[endCTemp] = 0;
	               }
		    }
		    else {//RECHTE TASTE
		       rightPress = true;
	   
		       //Bestimmung von endCtemp und Subtraktion
	               for (endCTemp = beginCTemp; endCTemp < 6; endCTemp++) {
		          if (value[endCTemp] > 0) {
		            value[endCTemp] --;
		            break;
		          }
		         else
		          value[endCTemp] = 9;
	               }	 
		    }
		       
		    if (endCTemp != 6)
                      new Thread(this).start();//Action!
		     else {//Auf alte Werte wiederzuruecksetzen
		      if (!rightPress) {
			 
 		        textArea.setText(TextData.calculator_over);		      			 
			 
			for (int j=beginCTemp; j<6; j++)
			   value[j] = 9;
		      }
		      else {

 		        textArea.setText(TextData.calculator_under);
			 
			for (int j=beginCTemp; j<6; j++)
			   value[j] = 0;
		      }
		      rightPress = false;
		      active = false;
		     }
		       
	           break;
	         }
	       }
	    }
	  }
	}
      }
    }
		
   wakeupOn (wakeupAWT);
  }
   
   public void run () {
      int i,j;

      if (soundSet)
        sound.setEnable(true);      
      
      if (!rightPress) {//ADDIEREN
      
      if (endCTemp == 0) {
	            
         for (i=0; i < duration; i++) {
	   currTrans[0].mul(dRotateY, currTrans[0]);//Umkehren?
           currGrp[0].setTransform(currTrans[0]);
	 }

	 //Endcheck
	 currTrans[0].rotY(overall_angle * value[0]);
	 currGrp[0].setTransform(currTrans[0]);
	    
      }
      else {

	 endMTemp = endCTemp - 1;
	 if (beginCTemp != 0)
	   beginMTemp = beginCTemp - 1;
	   else
	   beginMTemp = 0;
	 	  
         for(i=0; i < duration; i++) {
	    for (j=beginCTemp; j <= endCTemp; j++) {
	       currTrans[j].mul(dRotateY, currTrans[j]);    
               currGrp[j].setTransform(currTrans[j]);
	    }
	    for (j=beginMTemp; j <= endMTemp; j++) {
	       middleTrans[j].mul(dMRotateY, middleTrans[j]);	    
               middleGrp[j].setTransform(middleTrans[j]);
	    }
         }
	 
	 //Endcheck
	 for (i=beginCTemp; i <= endCTemp; i++) {
  	   currTrans[i].rotY(overall_angle * value[i]);
	   currGrp[i].setTransform(currTrans[i]);
	 }
	 
	 for (i=beginMTemp; i <= endMTemp; i++) {
     	   middleTrans[i].rotY(-overall_angle * value[i]);
           middleGrp[i].setTransform(middleTrans[i]);
	 }

       }
      }
      else {//SUBTRAHIEREN, vertausche dRotateY mit dMRotateY
	 
      if (endCTemp == 0) {
	            
         for (i=0; i < duration; i++) {
	   currTrans[0].mul(dMRotateY, currTrans[0]);//Umkehren?
           currGrp[0].setTransform(currTrans[0]);
	 }

	 //Endcheck
	 currTrans[0].rotY(overall_angle * value[0]);
	 currGrp[0].setTransform(currTrans[0]);
	    
      }
      else {

	 endMTemp = endCTemp - 1;
	 if (beginCTemp != 0)
	   beginMTemp = beginCTemp - 1;
	   else
	   beginMTemp = 0;
	 	  
         for(i=0; i < duration; i++) {
	    for (j=beginCTemp; j <= endCTemp; j++) {
	       currTrans[j].mul(dMRotateY, currTrans[j]);    
               currGrp[j].setTransform(currTrans[j]);
	    }
	    for (j=beginMTemp; j <= endMTemp; j++) {
	       middleTrans[j].mul(dRotateY, middleTrans[j]);	    
               middleGrp[j].setTransform(middleTrans[j]);
	    }
         }
	 
	 //Endcheck
	 for (i=beginCTemp; i <= endCTemp; i++) {
  	   currTrans[i].rotY(overall_angle * value[i]);
	   currGrp[i].setTransform(currTrans[i]);
	 }
	 
	 for (i=beginMTemp; i <= endMTemp; i++) {
     	   middleTrans[i].rotY(-overall_angle * value[i]);
           middleGrp[i].setTransform(middleTrans[i]);
	 }

       }
      }

    if (soundSet)
      sound.setEnable(false);
      
    rightPress = false;
    active = false;
   }
}
