//Alles!
//Endversion 1

//ALLE WRL-DATEIEN OHNE KAMERA, VIEWPOINT UND APPEARANCES!!!!!
//1 ist rechts, 6 ist links; Nullpkt. ist Mittelpunkt von 6. Zylinder
//TODO: Wieviele IMPORTS? Global_Bounds auch fuer die Picking-Behaviors?
//1->hell (Gehaeuse), 2->dunkel (Schieber)

import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.behaviors.picking.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.image.TextureLoader;

import java.awt.TextArea;
import java.awt.Cursor;

import com.sun.j3d.loaders.Scene;
import java.io.FileNotFoundException;
import com.sun.j3d.loaders.vrml97.VrmlLoader;
import java.net.URL;
import java.net.MalformedURLException;

public class Schickard {
   
    //Klassendaten
    public static final String rotateID = "ENABLE_ROTATE_MARK";
    public static final String moveID  = "ENABLE_MOVE_MARK";
    public static final String calcID  = "CALCULATOR";
    private TransparencyAttributes transparencyCase = new TransparencyAttributes(TransparencyAttributes.SCREEN_DOOR,0.0f);
    private BranchGroup calcPart_1 = new BranchGroup();
    private BranchGroup calcPart_2 = new BranchGroup();
    private BranchGroup calcPart_3 = new BranchGroup();
    private BranchGroup slide1 = new BranchGroup();
    private BranchGroup slide2 = new BranchGroup();
    private static final Transform3D identity = new Transform3D();
    private Vector3f vec = new Vector3f();
    private Vector3f inc = new Vector3f();
    private Transform3D trafoMatrix = new Transform3D();//NUR FUER TRANSLATION!!!!!
    private TransformGroup[] rotC = new TransformGroup[6];
    private TransformGroup[] rotM = new TransformGroup[6];
    private TransformGroup[] tgS = new TransformGroup[8];
    private PickTurnCalculator calcBehavior;
    private PickHelp helpBehavior;
    private TextureLoader tex;
    private Canvas3D canvas;
    private URL context;
    private URL url;
    private Appearance appCase;
    private Appearance appSlide;
    private Texture textureCase;
    private Texture textureSlide;
   
    //Leerer Defaultkonstruktor
    public Schickard() {
    }

    //Capabilitaetsfunktionen und Default Appearance richtig setzen (VOR LIVE!!!! UND VOR EINFUEGEN VON OBJEKT IN SZENEGRAPH!!!!!)
    private void initializeObject(Object obj, Appearance app)
    {
     if (obj instanceof Group)
       {
        Group theGroup = (Group) obj;
	  
        try
        {
         for (java.util.Enumeration e = theGroup.getAllChildren(); e.hasMoreElements();)
            {
              Object theKid = e.nextElement();
              initializeObject(theKid, app);
            }
        }
        catch (Exception ex)
        {
           System.err.println(ex);
        }
       }
     else
       if (obj instanceof Shape3D)
	 {
	  ((Shape3D) obj).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);//Wegen Picken
	  ((Shape3D) obj).setAppearance(app);
	 }
    } 
   
    //Transparenzaenderung
    //Achtung: Falls ganz unsichtbar, stimmt Picken so nicht mehr! Bei Transparenz egal.
    public void transparencyChangeCallback(boolean state) {
     if (state)
       transparencyCase.setTransparency(0.6f);
      else
       transparencyCase.setTransparency(0.0f);
     }
  
   //Appearanceaenderung (nach Texturaenderung)
   public void textureChangeCallback(boolean state) {
       //Gehaeuse gut: 14wy25, ~wood-08, ~wood-04 (~wood-04 aehnlich wie 14wy25, aber kleinere Datei) -> ~wood04.jpg
       //Schieber: 14wy15, 12wy20 (Grob) (~wood08 aehnlich wie 14wy15 aber kleinere Datei) -> ~wood08.jpg

       if (state) {
	 appCase.setTexture(textureCase);
	 appSlide.setTexture(textureSlide);
       }
       else {
	 appCase.setTexture(null);
	 appSlide.setTexture(null);
      }
    }
   
    //Hier wird der Szenegraph erstellt
    public Node createScene (Canvas3D canvas, Bounds globalBounds, TextArea textArea, Cursor helpCursor, URL context) {
////////
////////
////////
////////ALLGEMEIN
////////
        BranchGroup sceneRoot = new BranchGroup();       
        this.canvas = canvas;
        this.context = context;
      
        //Haeufig gebrauchte Objekte
        VrmlLoader vrmlLoader = new VrmlLoader();
        Scene scene=null;
	Transform3D trafoMatrix2 = new Transform3D();//Nicht nur fuer Translation!
        TurnButton turnButton = new TurnButton(canvas, context);
       
        transparencyCase.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
       
        appCase = new Appearance();
        appCase.setCapability(Appearance.ALLOW_TEXTURE_WRITE);
        appCase.setMaterial(MaterialData.brown1M);
        appCase.setTransparencyAttributes(transparencyCase);

        try {
	        url = new URL(context, "textures/wswood1.jpg");
                tex = new TextureLoader(url, canvas);	   
                System.out.println(url.toString());
                textureCase = tex.getTexture();
	    }
	  catch (MalformedURLException meme) {
	    }
       
        appSlide = new Appearance();
        appSlide.setCapability(Appearance.ALLOW_TEXTURE_WRITE);
        appSlide.setMaterial(MaterialData.brown2M);

        try {
	        url = new URL(context, "textures/wswood2.jpg");
                tex = new TextureLoader(url, canvas);	   
                System.out.println(url.toString());
                textureSlide = tex.getTexture();
	    }
	  catch (MalformedURLException meme) {
	    }       
       
        //Setze Hintergrund auf Hellblau
        Background backGround = new Background(ColorConstants.skyBlue);
	backGround.setApplicationBounds(globalBounds);
	sceneRoot.addChild(backGround);

        //Erstelle Lichter, damit man alles besser erkennen kann (Werte aus NCSA-Display)
	PointLight pointLight = new PointLight();
        pointLight.setPosition(new Point3f(30,30,20));//!ALT: (30,0,20)
	pointLight.setColor(ColorConstants.white);
	pointLight.setInfluencingBounds(globalBounds);

	AmbientLight ambientLight = new AmbientLight(true,ColorConstants.white);
	ambientLight.setInfluencingBounds(globalBounds);

        vec.set(0.0f,0.0f,25.0f);//!
	trafoMatrix.setTranslation(vec);
	TransformGroup lightTrafoGroup = new TransformGroup(trafoMatrix);

	lightTrafoGroup.addChild(pointLight);
	lightTrafoGroup.addChild(ambientLight);
	sceneRoot.addChild(lightTrafoGroup);
       
        //Verkleinere alles um den Faktor 10 (TODO: implizit! GANZ AM ENDE! Wenn ueberhaupt...)
        Transform3D makeSmaller3D = new Transform3D();
        makeSmaller3D.setScale(0.1);
        TransformGroup makeSmallerGroup = new TransformGroup(makeSmaller3D);
        sceneRoot.addChild(makeSmallerGroup);
  
////////
////////
////////
////////GEHAEUSE 1
////////(Nullpunkt ist links hinten unten, in Pytha implizite Verschiebung um "(-9.5f,-34.5f,-8f)", sowie 6cm unten abgeschnitten!)
////////
	try {
	     try {
		url = new URL(context, "models/wscase1.wrl");//OHNE VIEWP. UND APP., MIT TEXT.KOORD./NORMALEN //ALT: ws_geh1_w.wrl
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }	   
	     calcPart_1 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }
       
        initializeObject(calcPart_1, appCase);
        makeSmallerGroup.addChild(calcPart_1);

////////
////////CYLINDER (Bessere Textur, Auf Null drehen und vor allem richtig rum!, weiter an Fenster ran?)
////////
        //Erzeuge Translations und Rotationsknoten mit Linkknoten auf sharedCylinderSection
        CylinderSection sharedCylinderSection = new CylinderSection(canvas, turnButton, context);
        TransformGroup[] tgC = new TransformGroup[6];

        vec.set(37.5f,0.0f,0.0f);
        inc.set(-7.5f,0.0f,0.0f);
        //Initialisiere (0 ist 1.Zylinder (ganz rechts), 5 ist 6.Zylinder (ganz links))
        for (int i = 0; i < 6; i++) {
	   tgC[i] = new TransformGroup();
	   trafoMatrix.setTranslation(vec);
	   tgC[i].setTransform(trafoMatrix);
	   makeSmallerGroup.addChild(tgC[i]);

	   vec.add(inc);	   
	   
	   rotC[i] = new TransformGroup();
           rotC[i].setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
           rotC[i].setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
           rotC[i].setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	   rotC[i].setUserData(new CheckID(rotateID,i+1));
	   tgC[i].addChild(rotC[i]);
	   
	   rotC[i].addChild(new Link(sharedCylinderSection));
	}

////////
////////1.Schieber
////////(Nullpkt. in Pytha links hinten unten, implizite Verschiebung in Pytha um "(-8.5f,13.7f,4f)")
	try {
	     try {
		url = new URL(context, "models/wsslide1.wrl");//OHNE VIEWP. UND APP., MIT TEXT.KOORD./NORMALEN //ALT: ws_schb1z.wrl
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());
	     }
	     catch (MalformedURLException meme) {
	     }	   
	     slide1 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }

        initializeObject(slide1, appSlide);
        makeSmallerGroup.addChild(slide1);
      
////////
////////SCHIEBER 2-8 (kleinere Fenster?)
////////
        //Erzeuge Standardcylinder (fuer links/rechts mit Zahlen) zum Klonen und Klone
        Cylinder[] cylinder = new Cylinder[8];

        cylinder[0] = new Cylinder(1.65f, 1.6f, Cylinder.GENERATE_TEXTURE_COORDS | Cylinder.GENERATE_NORMALS, AppData.brown1A);
        cylinder[0].getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        cylinder[0].getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        cylinder[0].getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);       

        for (int i = 1; i < 8; i++)//Von 3-9
	   cylinder[i] = (Cylinder) cylinder[0].cloneTree();
       
        //Erstelle Appearances und verknuepfe mit ShareGroups
        Appearance[] cylinderApp = new Appearance[8];//Appearances fuer Zylinderoberflaeche (links/rechts) mit Zahlen
        SharedGroup[] sCylinder = new SharedGroup[8];
        String textData = "";
       
        for (int i = 0; i < 8; i++) {//Von 2-9

	   cylinderApp[i] = new Appearance();
           cylinderApp[i].setMaterial(MaterialData.brown1M);

	   try {
		url = new URL(context, "textures/wsd" + (i+2) + ".jpg");//ODER OHNE ANTIALIASING wss.
                tex = new TextureLoader(url, canvas);
                cylinderApp[i].setTexture(tex.getTexture());
                System.out.println(url.toString());
	     }
	     catch (MalformedURLException meme) {
	     }       
	   
           cylinder[i].getShape(Cylinder.TOP).setAppearance(cylinderApp[i]);
	   
	   sCylinder[i] = new SharedGroup();
	   sCylinder[i].addChild(cylinder[i]);
	}	   
	   
        //Erzeuge Trafomatrix und Knoten fuer Cylinder links/rechts
        Transform3D trafoCylinderLeft = new Transform3D();
        vec.set(-12.5f,1.65f,0.5f);
        trafoCylinderLeft.rotX(Math.PI / 2.0);
        trafoCylinderLeft.setTranslation(vec);
       
        Transform3D trafoCylinderRight = new Transform3D();
        vec.set(63.25f,1.65f,0.5f);
        trafoCylinderRight.rotX(Math.PI / 2.0);
        trafoCylinderRight.setTranslation(vec);
       
        TransformGroup[] tgCylinderLeft = new TransformGroup[8];
        TransformGroup[] tgCylinderRight = new TransformGroup[8];

        //Lese Schieber 2 ein
	try {
	     try {
		url = new URL(context, "models/wsslide2.wrl");//OHNE VIEWP. UND APP., MIT TEXT.KOORD./NORMALEN //ALT(MIT VIEWPOINT): wsslid2.wrl (SEHR ALT: ws_sch2z.wrl)
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }
	     slide2 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }

        initializeObject(slide2, appSlide);
       
        //Erzeuge NUR Translationsknoten mit Link auf sharedCylinderSection und Zylinder
        SlideSection sharedSlideSection = new SlideSection(slide2);
              
        vec.set(-4.75f,10.2f,4f);//Zu, waere offen -8.5f
        inc.set(0.0f,-3.5f,0.0f);      
        //Initialisiere (0 ist 2.Schieber (ganz oben), 7 ist 9.Zylinder (ganz unten))
        for (int i = 0; i < 8; i++) {
	   tgS[i] = new TransformGroup();
	   trafoMatrix.setTranslation(vec);
	   tgS[i].setTransform(trafoMatrix);
	   makeSmallerGroup.addChild(tgS[i]);
	   
	   vec.add(inc);
	   
           tgS[i].setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
           tgS[i].setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
           tgS[i].setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	   tgS[i].setUserData(new CheckID(moveID,i+2));
	   
	   tgS[i].addChild(new Link(sharedSlideSection));
	   
	   tgCylinderLeft[i] = new TransformGroup(trafoCylinderLeft);
	   tgCylinderRight[i] = new TransformGroup(trafoCylinderRight);
	   
	   tgCylinderLeft[i].addChild(new Link(sCylinder[i]));
	   tgCylinderRight[i].addChild(new Link(sCylinder[i]));
	   
	   tgS[i].addChild(tgCylinderLeft[i]);
	   tgS[i].addChild(tgCylinderRight[i]);
	}

////////
////////
////////
////////GEHAEUSE 2 - ZAHNRAEDER RICHTIG EINSTELLEN!!!!!!!!!!! TRANSLATIONEN implizit!!!!!!!!!
////////(ALTE TRANSLATION (tgGeh2) : vec.set(0.0f,-19.5f,11.5f); vor Implizitisierung)
////////(In Pytha implizite Verschiebung um "(-9.5f,-34.5f,6.0f)"), und Abschneiden unten von 6cm (Y))
     
	try {
	     try {
		url = new URL(context, "models/wscase2.wrl");//OHNE VIEWP. UND APP., MIT TEXT.KOORD./NORMALEN //ALT: ws_geh2z.wrl
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }	   
	     calcPart_2 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }

        initializeObject(calcPart_2, appCase);
        makeSmallerGroup.addChild(calcPart_2);
     
////////
////////Lade ZAHNRAEDER ein (ACHTUNG ALLES ZEIGT NOCH NACH OBEN (Y) NICHT NACH VORNE (Z)!
////////In Pytha wurden folgende Transformationen impliziert: (Zahnraeder "ws10..." liegen zunaechst in Y/Z-Ebene)
////////Vollst. 10-Rad: rotX(-2*Math.PI * 0.027) = -9.72 Grad (Vollst. Raeder drehen in andere Richtung als Ueberg.rad/vollst.Rad auf Ueberg.achse)
////////1-Rad:          rotX(2*Math.PI * 0.075)  = 27 Grad (Damit gerade nach Uebertrag)
////////Ueberg.-Rad:    rotX(2*Math.PI * 0.027)  = 9.72 Grad (Damit in Richtung 1-Rad schaut)
////////Danach jedes Zahnrad: rotZ(Math.PI/2.0) = 90 Grad drehen (Z), damit nach oben (Y) schaut.
////////Schliesslich alles um den Faktor 10 verkleinern (da noch ungef. 35 cm gross), und dann noch mit dem Faktor 0.857143 (=3/3.5) skalieren,
////////damit ungefaehr 3cm gross. (also insgesamt set.Scale(0.0857143). [In Pytha 2*"Dehnen" mit Ruhepkt. (0,0,0)]
////////Allg. Subtrahieren -> + ...Grad
      
        BranchGroup gear1 = new BranchGroup();
        BranchGroup gear2 = new BranchGroup();
        BranchGroup gear3 = new BranchGroup();
        SharedGroup sGear1 = new SharedGroup();
        SharedGroup sGear2 = new SharedGroup();
        SharedGroup sGear3 = new SharedGroup();    
             
        //Lade Zahnrad 1: (Vollst. 10-Rad)
	try {
	     try {
		url = new URL(context, "models/wsg10.wrl");//SCHON OHNE VIEWPOINT UND APP. (ALT: ws10.wrl)
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }
	     gear1 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }

        initializeObject(gear1, AppData.redA);
        sGear1.addChild(gear1);			     
       
        //Lade Zahnrad 2: (1-Rad)
	try {
	     try {
		url = new URL(context, "models/wsg1.wrl");//SCHON OHNE VIEWPOINT UND APP. (ALT: ws10einer.wrl)
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }
	     gear2 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }

        initializeObject(gear2, AppData.grayA);
        sGear2.addChild(gear2);			     
       
        //Lade Zahnrad 3: (10-Uebergangs-Rad)
	try {
	     try {
		url = new URL(context, "models/wsg10u.wrl");//SCHON OHNE VIEWPOINT UND APP. (ALT: ws10halb.wrl)
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }
	     gear3 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }

        initializeObject(gear3, AppData.brown2A);
        sGear3.addChild(gear3);       
       
////////
////////Erzeuge sSubSection bestehend aus Trommel, Achse und Drehrad (Nullpunkt ist Nullpunkt Trommel)
////////
        SubSection sSubSection = new SubSection(canvas, context);
       
////////
////////Erzeuge d-e-Section
////////
        SharedGroup deSection = new SharedGroup();
        deSection.addChild(new Link(sSubSection));
        
        vec.set(0.0f,-3.5f,0.0f);//d//Oberteil ist Null
        trafoMatrix.setTranslation(vec);       
        TransformGroup tgDEGear1 = new TransformGroup(trafoMatrix);
        tgDEGear1.addChild(new Link(sGear1));
        deSection.addChild(tgDEGear1);
       
        vec.set(0.0f,-1.5f,0.0f);//e
        trafoMatrix.setTranslation(vec);       
        TransformGroup tgDEGear2 = new TransformGroup(trafoMatrix);
        tgDEGear2.addChild(new Link(sGear2));
        deSection.addChild(tgDEGear2);       
////////
////////Erzeuge e-d-Section
////////
        SharedGroup edSection = new SharedGroup();
        edSection.addChild(new Link(sSubSection));
        
        vec.set(0.0f,-2.5f,0.0f);//d//Oberteil ist Null
        trafoMatrix.setTranslation(vec);       
        TransformGroup tgEDGear1 = new TransformGroup(trafoMatrix);
        tgEDGear1.addChild(new Link(sGear1));
        edSection.addChild(tgEDGear1);

        vec.set(0.0f,-4.5f,0.0f);//e
        trafoMatrix.setTranslation(vec);       
        TransformGroup tgEDGear2 = new TransformGroup(trafoMatrix);
        tgEDGear2.addChild(new Link(sGear2));
        edSection.addChild(tgEDGear2);
////////
////////Erzeuge Translations und Rotationsknoten mit Linkknoten auf de/edSection
////////
        TransformGroup[] tgG = new TransformGroup[6];
        TransformGroup[] rotG = new TransformGroup[6];

	trafoMatrix2.rotX(Math.PI/2.0);//ERST HIER AM SCHLUSS ROTIEREN UM 90 GRAD UM X-ACHSE, d.h. vorher noch wie wenn Y,Z vertauscht waeren!
        
        vec.set(37.5f,-19.5f,11.5f);//Hier wieder richtige X/Y/Z //ORIGINAL vec.set(37.5f,0.0f,0.0f); Vor +tgGeh2
       
        inc.set(-7.5f,0.0f,0.0f);
        //Initialisiere (0 ist 1.CalcEinheit (ganz rechts), 5 ist 6.CalcEinheit (ganz links))
        for (int i = 0; i < 6; i++) {
	   tgG[i] = new TransformGroup();
	   trafoMatrix2.setTranslation(vec);
	   tgG[i].setTransform(trafoMatrix2);
	   makeSmallerGroup.addChild(tgG[i]);//NACH +tgGeh2

	   vec.add(inc);
	   
	   rotG[i] = new TransformGroup();
           rotG[i].setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
           rotG[i].setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
           rotG[i].setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	   rotG[i].setUserData(new CheckID(calcID,i));
	   tgG[i].addChild(rotG[i]);
	   
	   if ((i%2) == 0)
  	     rotG[i].addChild(new Link(edSection));//1.,3.,5. Einheit
	    else
	     rotG[i].addChild(new Link(deSection));//2.,4.,6. Einheit
	}

////////
////////Uebergangsraeder (ACHTUNG NOCH ZEIGT WIEDER ALLES NACH OBEN)
////////
        //Erzeuge Achse2
        Cylinder axis2 = new Cylinder(0.25f,6.5f,AppData.brown1A);
        vec.set(0.0f,-2.25f,0.0f);
        trafoMatrix.setTranslation(vec);
        TransformGroup trafoAxis2 = new TransformGroup(trafoMatrix);
        SharedGroup sAxis2 = new SharedGroup();
        trafoAxis2.addChild(axis2);
        sAxis2.addChild(trafoAxis2);

        axis2.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis2.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis2.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);              
////////
////////Erzeuge u-d-Section
////////
        SharedGroup udSection = new SharedGroup();
        udSection.addChild(new Link(sAxis2));
        
        vec.set(0.0f,-4.5f,0.0f);//u
        trafoMatrix.setTranslation(vec);
        TransformGroup tgUDGear3 = new TransformGroup(trafoMatrix);
        tgUDGear3.addChild(new Link(sGear3));
        udSection.addChild(tgUDGear3);

        vec.set(0.0f,-3.5f,0.0f);//d
        trafoMatrix2.rotY(4.0 * Math.PI * 0.027);//Damit gut Zahnraeder ineinander (wieder andersrum drehen)
        trafoMatrix2.setTranslation(vec);
        TransformGroup tgUDGear1 = new TransformGroup(trafoMatrix2);
	   
        tgUDGear1.addChild(new Link(sGear1));
        udSection.addChild(tgUDGear1);
////////
/////////Erzeuge d-u-Section
////////
        SharedGroup duSection = new SharedGroup();
        duSection.addChild(new Link(sAxis2));
        
        vec.set(0.0f,-1.5f,0.0f);//u
        trafoMatrix.setTranslation(vec);
        TransformGroup tgDUGear3 = new TransformGroup(trafoMatrix);
        tgDUGear3.addChild(new Link(sGear3));
        duSection.addChild(tgDUGear3);

        vec.set(0.0f,-2.5f,0.0f);//d
        trafoMatrix2.rotY(4.0 * Math.PI * 0.027);//Damit gut Zahnraeder ineinander (wieder andersrum drehen)
        trafoMatrix2.setTranslation(vec);
        TransformGroup tgDUGear1 = new TransformGroup(trafoMatrix2);
	   
        tgDUGear1.addChild(new Link(sGear1));
        duSection.addChild(tgDUGear1);
////////
////////Erzeuge Translations und Rotationsknoten mit Linkknoten auf du/ud-Section
////////
        TransformGroup[] tgU = new TransformGroup[5];
        TransformGroup[] rotU = new TransformGroup[5];

	trafoMatrix2.rotX(Math.PI/2.0);//ERST HIER AM SCHLUSS ROTIEREN UM 90 GRAD UM X-ACHSE, d.h. vorher noch wie wenn Y,Z vertauscht waeren!
       
        vec.set(33.75f,-23.25f,11.5f);//Hier wieder richtige X/Y/Z //ORIGINAL vec.set(33.75f,-3.75f,0.0f); VOR +tgGeh2
       
        //inc.set(-7.5f,0.0f,0.0f); //Schon oben
        //Initialisiere (0 ist 1.Uebergangs-CalcEinheit (ganz rechts), 5 ist 6.Uebergangs-CalcEinheit (ganz links))
        for (int i = 0; i < 5; i++) {
	   tgU[i] = new TransformGroup();
	   trafoMatrix2.setTranslation(vec);
	   tgU[i].setTransform(trafoMatrix2);
	   makeSmallerGroup.addChild(tgU[i]);//NACH +tgGeh2

	   vec.add(inc);
	   
	   rotU[i] = new TransformGroup();
           rotU[i].setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
           rotU[i].setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	   tgU[i].addChild(rotU[i]);
	   
	   if (i%2 == 0)
  	     rotU[i].addChild(new Link(udSection));
	    else
	     rotU[i].addChild(new Link(duSection));
	}

////////
////////
////////
//////////GEHAEUSE 3 - FERTIG BIS AUF: BESSERE MODELLIERUNG (SCHRAEG, niedriger) UND TEXTUR FUER SPEICHERRAD richtig rum
////////(Trafo (vor implizit) von altem Schickard war: (0.0f,-26.0f,22.0f))
////////(Nullpkt. links hinten unten in Pytha, implizite Verschiebung in Pytha um "(-9.5,-34.5,13.5)", und Abschneiden von 6cm (Y))
          
	try {
	     try {
		url = new URL(context, "models/wscase3.wrl");//OHNE VIEWP. UND APP., MIT TEXT.KOORD./NORMALEN //ALT: ws_geh3_w.wrl
                scene = vrmlLoader.load(url);
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }
	     calcPart_3 = scene.getSceneGroup();
	    }
        catch (FileNotFoundException fnfe)
	    {
	     System.out.println("File not found.");
	    }

        initializeObject(calcPart_3, appCase);
        makeSmallerGroup.addChild(calcPart_3);
	   
////////
////////MEMORY
////////
        //Erzeuge Translations und Rotationsknoten mit Linkknoten auf sharedMemorySection
        MemorySection sharedMemorySection = new MemorySection(canvas, turnButton, context);
        TransformGroup[] tgM = new TransformGroup[6];
       
        vec.set(37.5f,-26.0f,22.0f);//VOR IMPLIZIT: (37.5, 0.0, 0.0)
        inc.set(-7.5f,0.0f,0.0f);//Eigentlich schon oben, aber wegen auskommentieren!
        //Initialisiere (0 ist 1.Sektion (ganz rechts), 5 ist 6.Sektion (ganz links))
        for (int i = 0; i < 6; i++) {
	   tgM[i] = new TransformGroup();
	   trafoMatrix.setTranslation(vec);
	   tgM[i].setTransform(trafoMatrix);
	   makeSmallerGroup.addChild(tgM[i]);

	   vec.add(inc);	   
	   
	   rotM[i] = new TransformGroup();
           rotM[i].setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
           rotM[i].setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
           rotM[i].setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	   rotM[i].setUserData(new CheckID(rotateID,i+7));
	   tgM[i].addChild(rotM[i]);
	   
	   rotM[i].addChild(new Link(sharedMemorySection));
	}	    
				    				    
////////
////////
////////
////////Alle Picking Behavior
////////
        PickEngineRotateY turnBehavior = new PickEngineRotateY(sceneRoot, canvas, globalBounds, rotateID,
 							       10000,-Math.PI/5.0, PickObject.USE_GEOMETRY);				    
        sceneRoot.addChild(turnBehavior);

        PickMouseTranslateXLimit moveSlide = new PickMouseTranslateXLimit(sceneRoot, canvas, globalBounds, moveID,
									  -8.5,-4.75,PickObject.USE_GEOMETRY);//3.75 Spielraum
        moveSlide.getBehavior().setXFactor(0.25);//ALT 0.1
	sceneRoot.addChild(moveSlide);

        calcBehavior = new PickTurnCalculator(sceneRoot, canvas, globalBounds, rotG, rotU, calcID,
					      20000, -Math.PI / 5.0d, PickObject.USE_GEOMETRY, textArea);
	sceneRoot.addChild(calcBehavior);

        helpBehavior = new PickHelp(sceneRoot, canvas, globalBounds, textArea, helpCursor);
        helpBehavior.setEnable(false);				    
	sceneRoot.addChild(helpBehavior);

////////
////////
////////SoundNode-Erstellung
////////
       try {
  	     url = new URL(context, "sounds/dooropen.wav");
				    
             MediaContainer sample1 = new MediaContainer(url);
             System.out.println(url.toString());	   
             sample1.setCacheEnable(false);//?
       
             BackgroundSound sound1 = new BackgroundSound(sample1,0.8f,0,true,false,false,globalBounds,1.0f);//OHNE LOOP
             sound1.setCapability(Sound.ALLOW_ENABLE_WRITE);
             sceneRoot.addChild(sound1);
	  
    	     turnBehavior.setSound(sound1);
	   }
	 catch (MalformedURLException meme) {
	 }
				    
       try {
  	     url = new URL(context, "sounds/doorslam.wav");

	     MediaContainer sample2 = new MediaContainer(url);
             System.out.println(url.toString());
             sample2.setCacheEnable(true);//?
       
             BackgroundSound sound2 = new BackgroundSound(sample2,0.8f,-1,false,false,false,globalBounds,2.0f);//MIT LOOP
             sound2.setCapability(Sound.ALLOW_ENABLE_WRITE);
             sceneRoot.addChild(sound2);

	     calcBehavior.setSound(sound2);	  
	   }
	 catch (MalformedURLException meme) {
	 }
				    
////////
////////
////////
////////bergabe des Knotens
////////
        return sceneRoot;
    }

 //Reset-Callbackfunktion von allen Knoten, die pickable sind
 public void setReset() {			     

   for (int i=0; i<6; i++) {
    rotC[i].setTransform(identity);
    rotM[i].setTransform(identity);
   }

   vec.set(-4.75f,10.2f,4f);//Zu, waere offen -8.5f
   inc.set(0.0f,-3.5f,0.0f);      
   //Initialisiere (0 ist 2.Schieber (ganz oben), 7 ist 9.Zylinder (ganz unten))
   for (int i = 0; i < 8; i++) {
      trafoMatrix.setTranslation(vec);
      tgS[i].setTransform(trafoMatrix);
      vec.add(inc);
   }

   calcBehavior.setReset(identity);   
 }

 //Direkthilfe ab/an-schalten
 public void changeHelpStatus(boolean state) {			     
  helpBehavior.setEnable(state);
 }			     
}
