//Speicherrad-Abschnitt (Noch alles mit Nullpkt. Basis Drehscheibe)
//Endversion 1

//Position Drehscheibenboden-Mitte entspricht (0,-0.25,0) in cm

//KOMMENTARE:
//So uebersichtlicher, ausserdem Moeglichkeit beim Picken direkt Drehen ohne Translation

import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;
import com.sun.j3d.utils.image.TextureLoader;

import java.net.URL;
import java.net.MalformedURLException;

public class MemorySection extends SharedGroup {

    public MemorySection(java.awt.Component observer, TurnButton turnButton, URL context) {
        super();
       
        //Achse
        Cylinder axis = new Cylinder(0.5f,1.25f, AppData.brown2A);
       
        axis.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);       

        //Zylinder
        Cylinder cylinder = new Cylinder(3.75f, 0.5f, Cylinder.GENERATE_TEXTURE_COORDS | Cylinder.GENERATE_NORMALS, AppData.whiteA);
      
        Appearance app = new Appearance();
        app.setMaterial(MaterialData.whiteM);
       
	try {
		URL url = new URL(context, "textures/wsmemory.jpg");
                TextureLoader tex = new TextureLoader(url, observer);
                app.setTexture(tex.getTexture());
                System.out.println(url.toString());	   
	     }
	     catch (MalformedURLException meme) {
	     }       
       
        cylinder.getShape(Cylinder.TOP).setAppearance(app);
       
        cylinder.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        cylinder.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        cylinder.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
       
        //Einfuegen der Trafoknoten mit Blaettern
        Transform3D trafo = new Transform3D();
        
        trafo.setTranslation(new Vector3f(0.0f,2.0f,0.0f));//Unterschied in Hhe Boden Zylinder Boden Drehknopf ist 1.75 cm
        TransformGroup tg1 = new TransformGroup(trafo);
        tg1.addChild(new Link(turnButton));
        this.addChild(tg1);

        trafo.setTranslation(new Vector3f(0.0f,0.875f,0.0f));//Unterschied in Hhe Boden Zylinder Boden Achse ist 0.5 cm
        TransformGroup tg2 = new TransformGroup(trafo);
        tg2.addChild(axis);
        this.addChild(tg2);
       
        this.addChild(cylinder);
    }
}
