//PickEngineRotateY
//Verhalten, das auf Knopfdruck das gepickte Objekt um einen best. Winkel in einer best. Zeit weiterdreht.
//Pickt genau den TransformNode aus dem gepickten Pfad, der mit best. nameID "markiert" ist.

//Vor. WRITE/READ-ABLE muss klar sein.
//Und ohne TRANSLATION. ES MUSS EXTRA TRANSLATIONSKNOTEN EXISTIEREN!

//Version D

//KOMMENTARE:
//Kein Analogon zu MouseRotateY->PickRotateY, sondern total neue Klasse
//Damit Callback, kann z.B. transformChanged ueberschrieben werden
//Jetzt mit Endcheck und Cursoraenderung
//Besser ableiten? Nein, da sonst noch andere WakeUp-Kriterien
//Jetzt mit Unterstuetzung von rechter Maustaste!
//(Weiterspielen bei gedrueckt halten funktioniert nicht, ist aber auch egal)
//ACHTUNG: INVERT_INPUT und FLAGS weggelassen, da hier sinnlos!!!!! Umkehren mit negativem Winkel bei Uebergabe!
//(Sound nach Ablauf wieder disablen -> 1.unnoetig da nur kurz, 2.schlecht da vielleicht anderer Sound d.gleichen Behav. abgeschaltet wird)

//TODO: Kommentare weg oder verenglischen
//(TODO: Einlesen weglassen: ALLE MARKIERTEN KNOTEN WERDEN NUR DURCH DIESES VERHALTEN GEAENDERT!)

import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class PickEngineRotateY extends Behavior implements Runnable {
   
  protected PickObject pickScene;
  protected TransformGroup currGrp;
  protected MouseEvent mevent;
  protected WakeupOnAWTEvent pressCriterion;
  int pickMode = PickObject.USE_BOUNDS;

  protected double overall_angle;
  protected long duration;

  private Transform3D currXform;
  private Transform3D tempTrans;   
  private Transform3D dRotateY;
  private Transform3D RotateY;
  private Transform3D dNRotateY;
  private Transform3D NRotateY;

  private boolean rightPress = false;
  protected boolean active = false;
   
  private String nameID;
  private Object objectTemp;
   
  private Canvas3D canvas;
   
  private Sound sound;
  private boolean soundSet=false;
   
  public PickEngineRotateY(BranchGroup root, Canvas3D canvas, Bounds bounds, String nameID) {
    super();
    currGrp = new TransformGroup();
    pickScene = new PickObject(canvas, root);

    currXform = new Transform3D();
    tempTrans = new Transform3D();     
    duration = 10000;
    overall_angle = Math.PI / 2.0d;
    dRotateY = new Transform3D();
    dRotateY.rotY(Math.PI /2.0d / 10000.0d);
    RotateY = new Transform3D();
    RotateY.rotY(Math.PI /2.0d);
    dNRotateY = new Transform3D();
    dNRotateY.rotY(-Math.PI /2.0d / 10000.0d);
    NRotateY = new Transform3D();
    NRotateY.rotY(-Math.PI /2.0d);     

    this.setSchedulingBounds(bounds);
    this.nameID = nameID;
    this.canvas = canvas;
  }

  public PickEngineRotateY(BranchGroup root, Canvas3D canvas, Bounds bounds, String nameID,
				  long new_duration, double new_angle){
    super();
    currGrp = new TransformGroup();
    pickScene = new PickObject(canvas, root);
     
    currXform = new Transform3D();
    tempTrans = new Transform3D();          
    duration = new_duration;
    overall_angle = new_angle;
    dRotateY = new Transform3D();
    dRotateY.rotY(overall_angle / ((double) duration));
    RotateY = new Transform3D();
    RotateY.rotY(overall_angle);
    dNRotateY = new Transform3D();
    dNRotateY.rotY(-overall_angle / ((double) duration));
    NRotateY = new Transform3D();
    NRotateY.rotY(-overall_angle);

    this.setSchedulingBounds(bounds);
    this.nameID = nameID;
    this.canvas = canvas;
  }
   
  public PickEngineRotateY(BranchGroup root, Canvas3D canvas, Bounds bounds, String nameID,
			   int pickMode){
    super();
    currGrp = new TransformGroup();
    pickScene = new PickObject(canvas, root);
     
    currXform = new Transform3D();
    tempTrans = new Transform3D();          
    duration = 10000;
    overall_angle = Math.PI / 2.0d;
    dRotateY = new Transform3D();
    dRotateY.rotY(Math.PI /2.0d / 10000.0d);
    RotateY = new Transform3D();
    RotateY.rotY(Math.PI /2.0d);
    dNRotateY = new Transform3D();
    dNRotateY.rotY(-Math.PI /2.0d / 10000.0d);
    NRotateY = new Transform3D();
    NRotateY.rotY(-Math.PI /2.0d);

    this.setSchedulingBounds(bounds);
    this.pickMode = pickMode;
    this.nameID = nameID;
    this.canvas = canvas;
  }
   
  public PickEngineRotateY(BranchGroup root, Canvas3D canvas, Bounds bounds, String nameID,
				  long new_duration, double new_angle, int pickMode){
    super();
    currGrp = new TransformGroup();
    pickScene = new PickObject(canvas, root);

    currXform = new Transform3D();
    tempTrans = new Transform3D();     
    duration = new_duration;
    overall_angle = new_angle;
    dRotateY = new Transform3D();
    dRotateY.rotY(overall_angle / ((double) duration));
    RotateY = new Transform3D();
    RotateY.rotY(overall_angle);
    dNRotateY = new Transform3D();
    dNRotateY.rotY(-overall_angle / ((double) duration));
    NRotateY = new Transform3D();
    NRotateY.rotY(-overall_angle);

    this.setSchedulingBounds(bounds);   
    this.pickMode = pickMode;
    this.nameID = nameID;
    this.canvas = canvas;
  }

   
  public void setSound(Sound sound) {   
   if (sound != null) {
     this.sound = sound;
     soundSet = true;
   } 
  }   
   
  public void setPickMode(int pickMode) {
    this.pickMode = pickMode;
  }

  public int getPickMode() {
    return pickMode;
  }
   
  public boolean isActive() {
   return active;
  }
   
  public long getDuration() {
    return duration;
  }
  
  public void setDuration( long new_duration ) {
   if (!active)
     duration = new_duration;
  }
   
  public double getOverallAngle() {
   return overall_angle;
  }
 
  public void setOverallAngle( double new_overall_angle ) {
   if (!active)
       {
        overall_angle = new_overall_angle;
        dRotateY = new Transform3D();
        dRotateY.rotY(overall_angle / ((double) duration));
        RotateY = new Transform3D();
        RotateY.rotY(overall_angle);
        dNRotateY = new Transform3D();
        dNRotateY.rotY(-overall_angle / ((double) duration));
        NRotateY = new Transform3D();
        NRotateY.rotY(-overall_angle);	  
       }
  }    
   
  public void initialize() {
    pressCriterion = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);
    wakeupOn (pressCriterion);
  }

  public void processStimulus (Enumeration criteria) {
    WakeupCriterion wakeup;
    AWTEvent[] evt = null;
    int xpos = 0, ypos = 0;

    while(criteria.hasMoreElements()) {
      wakeup = (WakeupCriterion)criteria.nextElement();
       
      if (wakeup instanceof WakeupOnAWTEvent)
	evt = ((WakeupOnAWTEvent)wakeup).getAWTEvent();
    }
    
    if (evt[0] instanceof MouseEvent){//Falls letztes Event Mouseevent war
      mevent = (MouseEvent) evt[0];
      xpos = mevent.getPoint().x;
      ypos = mevent.getPoint().y;
    }

    if (!active)
      updateScene(xpos, ypos);//Da mit Sicherheit Maus gedrueckt wurde
     
    wakeupOn (pressCriterion);
  }
   
  public void updateScene(int xpos, int ypos){//Passiert nur bei Mausdruck!(Noch extra Abfragen? Nein!)

    if (!mevent.isAltDown()){
       
      SceneGraphPath path = pickScene.pickClosest(xpos, ypos, pickMode);
       
      //GetNode beginnt bei 0 ganz oben!!!!!
      if (path != null) {
	 for (int i = 0; i < path.nodeCount(); i++) {
	    if (((objectTemp = path.getNode(i).getUserData()) instanceof CheckID) && (((CheckID) objectTemp).getID1() == nameID)){
	       	       
              if (mevent.isMetaDown())
	        rightPress = true;
	       
	      canvas.setCursor(SceneViewer3D.hand_cursor);
	      active = true;
              currGrp = (TransformGroup) path.getNode(i);
	       
              new Thread(this).start();//Action!
//              new Thread(System.getSecurityManager().getThreadGroup(),this).start();//Action!
	       
	      break;
	    }
         }
      }
    }
   }

   public void run () {
      currGrp.getTransform(currXform);//TODO WEGLASSEN, DA SICH NUR HIER AENDERT UND ANFANG MUSS IDENTITAET SEIN
      tempTrans.set(currXform);

      if (soundSet)
        sound.setEnable(true);
      
      if (!rightPress) {
        for(int n=0; n < duration; n++)
	  {
           currXform.mul(dRotateY, currXform);//Umkehren?
	   currGrp.setTransform(currXform);
	   transformChanged( currXform );
          }
	 
        //Endcheck:
	currXform.mul(RotateY,tempTrans);
	currGrp.setTransform(currXform);
	transformChanged( currXform ); 
      }
      else {	 	 
        for(int n=0; n < duration; n++)
	  {     
           currXform.mul(dNRotateY, currXform);
	   currGrp.setTransform(currXform);
	   transformChanged( currXform );
          }
	 
        //Endcheck:
	currXform.mul(NRotateY,tempTrans);
	currGrp.setTransform(currXform);
	transformChanged( currXform );
      }

    rightPress = false;
    active = false;
   }

  public void transformChanged( Transform3D transform ) {
  }
}
