//PickMouseTranslateXLimit (Verhalten wie PickTranslateBehavior, aber Aenderung nur bedingt mglich!) ==EXTRA!
//Version D

//KOMMENTARE:
//Damit Callback, muss PickingCallback implementiert werden (s. wuerfel6)
//Vor.: Transform Write/Read erlaubt, falls userData gesetzt wurde
//TODO: Kommentare weg oder verenglischen
//TODO: UNGENAU!

import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class PickMouseTranslateXLimit extends PickMouseBehavior implements MouseBehaviorCallback {
  MouseTranslateXLimit drag;//Use the new behavior MouseTranslateXLimit
  int pickMode = PickObject.USE_BOUNDS;
  private PickingCallback callback=null;
  private TransformGroup currentTG;
  private String testID;
  private Object objectTemp;
  
  private Canvas3D canvas;

  public PickMouseTranslateXLimit(BranchGroup root, Canvas3D canvas, Bounds bounds, String testID,
			     double x_min, double x_max){
    super(canvas, root, bounds);
    //Use the new behavior MouseTranslateXLimit with Manual_Wakeup!
    drag = new MouseTranslateXLimit(MouseTranslateXLimit.MANUAL_WAKEUP);
    drag.setXMin(x_min);
    drag.setXMax(x_max);
    drag.setTransformGroup(currGrp);
    currGrp.addChild(drag);
    drag.setSchedulingBounds(bounds);
    this.setSchedulingBounds(bounds);
    this.testID = testID;
    this.canvas = canvas;
  }

  public PickMouseTranslateXLimit(BranchGroup root, Canvas3D canvas, Bounds bounds, String testID,
			     double x_min, double x_max, int pickMode){
    super(canvas, root, bounds);
    //Use the new behavior MouseTranslateXLimit with Manual_Wakeup!
    drag = new MouseTranslateXLimit(MouseTranslateXLimit.MANUAL_WAKEUP);
    drag.setXMin(x_min);
    drag.setXMax(x_max);
    drag.setTransformGroup(currGrp);
    currGrp.addChild(drag);
    drag.setSchedulingBounds(bounds);
    this.setSchedulingBounds(bounds);     
    this.pickMode = pickMode;
    this.testID = testID;
    this.canvas = canvas;
  }

  public MouseTranslateXLimit getBehavior() {
   return drag;
  }

  /**
   * Sets the pickMode component of this PickRotateBehavior to the value of
   * the passed pickMode.
   * @param pickMode the pickMode to be copied.
   **/  


  public void setPickMode(int pickMode) {
    this.pickMode = pickMode;
  }

 /**
   * Return the pickMode component of this PickRotateBehavior.
   **/ 

  public int getPickMode() {
    return pickMode;
  }

//UEBERSCHREIBE INITIALIZE, DA UNNOETIG GROB!
  public void initialize() {

    conditions = new WakeupCriterion[1];
    conditions[0] = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);//ALT: Event.MOUSE_DOWN
    wakeupCondition = new WakeupOr(conditions);

    wakeupOn(wakeupCondition);
  }
   
  /**
   * Update the scene to manipulate any nodes. This is not meant to be 
   * called by users. Behavior automatically calls this. You can call 
   * this only if you know what you are doing.
   * 
   * @param xpos Current mouse X pos.
   * @param ypos Current mouse Y pos.
   **/
  public void updateScene(int xpos, int ypos){
    TransformGroup tg = null;
    int c=1;     
     
    if (!mevent.isMetaDown() && !mevent.isAltDown()){
       
      SceneGraphPath path = pickScene.pickClosest(xpos, ypos, pickMode);

      //GetNode beginnt bei 0 ganz oben!!!!!
      if (path != null) {
	 for (int i = 0; i < path.nodeCount(); i++)
	    if (((objectTemp = path.getNode(i).getUserData()) instanceof CheckID) && (((CheckID) objectTemp).getID1() == testID)){
	      canvas.setCursor(SceneViewer3D.hand_cursor);	      
              tg = (TransformGroup) path.getNode(i);
  	      drag.setTransformGroup(tg);
	      drag.wakeup();
	      currentTG = tg;
	      c=0;
	      break;
	    }
      }
    }
     
    if ((c==1) && (callback!=null))
      callback.transformChanged( PickingCallback.NO_PICK, null );     
 }

  /**
    * Callback method from MouseRotateY
    * This is used when the Picking callback is enabled
    */
  public void transformChanged( int type, Transform3D transform ) {
      callback.transformChanged( PickingCallback.ROTATE, currentTG );//TODO: ROTATEY
  }
 
  /**
    * Register the class @param callback to be called each
    * time the picked object moves
    */
  public void setupCallback( PickingCallback callback ) {
      this.callback = callback;
      if (callback==null)
          drag.setupCallback( null );
      else
          drag.setupCallback( this );
  }
}

