//Schieber-Abschnitt
//Endversion 1

import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class SlideSection extends SharedGroup {
    
    public SlideSection(BranchGroup slide) {
        super();

        this.addChild(slide);
       
        Transform3D trafo = new Transform3D();
        Vector3f vec = new Vector3f();
       
        //2 kleine Achsen
        Cylinder axis = new Cylinder(0.25f,0.75f, AppData.brown1A);
        SharedGroup sAxis = new SharedGroup();
        sAxis.addChild(axis);
       
        axis.getShape(Cylinder.BOTTOM).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis.getShape(Cylinder.TOP).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
        axis.getShape(Cylinder.BODY).getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
       
        vec.set(-5.0f,1.65f,1.375f);
        trafo.rotX(Math.PI / 2.0);
        trafo.setTranslation(vec);
        TransformGroup tAxis1 = new TransformGroup(trafo);
        tAxis1.addChild(new Link(sAxis));
        this.addChild(tAxis1);

        vec.set(55.75f,1.65f,1.375f);
        trafo.rotX(Math.PI / 2.0);		
        trafo.setTranslation(vec);       
        TransformGroup tAxis2 = new TransformGroup(trafo);
        tAxis2.addChild(new Link(sAxis));
        this.addChild(tAxis2);       
    }
}
