//TextData

import javax.vecmath.*;
import javax.media.j3d.Material;

class TextData{
   
public static final String introduction = "Welcome to the Java3D-visualization of the first calculator ever built "
 + "that was capable of adding, subtracting, multiplying and dividing natural numbers up to 6 digits.\n"
 + "Wilhelm Schickard constructed it in 1623.\n"
 + "GUIDED TOUR: Press Front View.\n"
 + "If you need help, press the icon on the right to get cursor-dependent directions for use.";

public static final String[] viewText = {
                                         "The calculator consists of three parts: The upper one is used to multiply/divide and therefore "
                                       + "consists of 6 cylinders with the multiplication tables. The middle one with the big turning wheels "
                                       + "is actually a standalone adding machine possessing 17 gears!\n" + "The bottom part is used to "
                                       + "memorize numbers that were used in the calculation.\n" + "-> GO TO Top View.",

                                         "Lets try to do the simple  calculation 63 * 7 - 2:\n"
                                       + "STEP 1: Turn the cylinders by the buttons on the top, until 63 is visible.\n"
                                       + "STEP 2: Move slide 7 to the left as far as possible so that the small windows in front of the cylinders "
                                       + "become visible.\n" + "-> GO TO Middle View.",
   
                                         "For each window in the 7th line do, if x is the LEFT, y the RIGHT number in it:\n"// For each window, where at least one of the two numbers (x,y) visible is not zero, do:\n"
                                       + "STEP 1: Turn y times the turnwheel directly below clockwise.\n"
                                       + "STEP 2: Turn x times the turnwheel left of that directly below clockwise.\n"
                                       + "CHECK YOURSELF: 1 times the 1st, (2+2) times the 2nd and 4 times the 3rd wheel.\n" + "-> GO TO Bird View.",

                                         "If you have done everything correctly the result 441 should be displayed in the middle.\n"
                                       + "Now turn the memory disc on the right below until 7 (the multiplicator) is visible.\n"
                                       + "Finally turn the 1st turn wheel from the right 2 times anticlockwise to subtract 2 from 441. "
                                       + "The result should be 439 = 63 * 7 - 2. Congratulations! "
                                       + "If you liked it, calculate 1000 - 1, make the case transparent and watch the gears move."
};

public static final String calculator_over = "This action is not possible, because this calculator can only handle numbers up to 1 million!";
public static final String calculator_under = "This action is not possible, because this calculator cannot handle negative numbers!";
public static final String reset = "Reset! All moveable parts are set to their initial status!";

}
