//Spezielles PickingBehavior, das nur einen bestimmten Knoten aendert, falls
//nichts oder nur ein 1-elementiger Pfad gepickt wurde oder nur MOVEID als CHECKID vorkommt (+Cursoraenderung)

//Version D

//TODO Nur bei speziellem UserData (z.B. auch bei Schieber)

import com.sun.j3d.utils.behaviors.picking.*;
import com.sun.j3d.utils.behaviors.mouse.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

public class ViewTranslateSpecial extends PickMouseBehavior implements MouseBehaviorCallback {
  MouseTranslate translate;
  int pickMode = PickObject.USE_BOUNDS;
  private PickingCallback callback = null;
  private TransformGroup currentTG;
  private TransformGroup specialGroup;
  private Object objectTemp;

  private Canvas3D canvas;
   
  public ViewTranslateSpecial(BranchGroup root, Canvas3D canvas, Bounds bounds, TransformGroup specialTrafoGroup){
    super(canvas, root, bounds);
    translate = new MouseTranslate(MouseBehavior.MANUAL_WAKEUP | MouseBehavior.INVERT_INPUT);//Da View
    currGrp.addChild(translate);
    translate.setTransformGroup(specialTrafoGroup);
    translate.setSchedulingBounds(bounds);
    this.setSchedulingBounds(bounds);
    specialGroup = specialTrafoGroup;
    currentTG = specialTrafoGroup;
     
    this.canvas = canvas;
  }

  public ViewTranslateSpecial(BranchGroup root, Canvas3D canvas, Bounds bounds,
 			       int pickMode, TransformGroup specialTrafoGroup){
    super(canvas, root, bounds);
    translate = new MouseTranslate(MouseBehavior.MANUAL_WAKEUP | MouseBehavior.INVERT_INPUT);//Da View
    currGrp.addChild(translate);     
    translate.setTransformGroup(specialTrafoGroup);
    translate.setSchedulingBounds(bounds);
    this.setSchedulingBounds(bounds);
    this.pickMode = pickMode;
    specialGroup = specialTrafoGroup;
    currentTG = specialTrafoGroup;
     
    this.canvas = canvas;
  }

//UEBERSCHREIBE INITIALIZE, DA UNNOETIG GROB!
  public void initialize() {

    conditions = new WakeupCriterion[1];
    conditions[0] = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);//ALT: Event.MOUSE_DOWN
    wakeupCondition = new WakeupOr(conditions);

    wakeupOn(wakeupCondition);
  }
   
  /**
   * Sets the pickMode component of this PickTranslateBehavior to the value of
   * the passed pickMode.
   * @param pickMode the pickMode to be copied.
   **/  

  public void setPickMode(int pickMode) {
    this.pickMode = pickMode;
  }

 /**
   * Return the pickMode component of this PickTranslaeBehavior.
   **/ 

  public int getPickMode() {
    return pickMode;
  }

  /**
   * Update the scene to manipulate any nodes. This is not meant to be 
   * called by users. Behavior automatically calls this. You can call 
   * this only if you know what you are doing.
   * 
   * @param xpos Current mouse X pos.
   * @param ypos Current mouse Y pos.
   **/
  public void updateScene(int xpos, int ypos){
    TransformGroup tg = null;
   
    if (mevent.isMetaDown() && !mevent.isAltDown()){
      SceneGraphPath path = pickScene.pickClosest(xpos, ypos, pickMode);
              
       if ((path == null) || (path.nodeCount() == 1))
	 {
          canvas.setCursor(SceneViewer3D.move_cursor);
	  translate.setTransformGroup(specialGroup);//Wegen Reset!
 	  translate.wakeup();
	 }
      else {
         int c = 0;
	 for (int i = 0; i < path.nodeCount(); i++)
	    if (((objectTemp = path.getNode(i).getUserData()) instanceof CheckID) && (((CheckID) objectTemp).getID1() != Schickard.moveID)) {
	      c = 1;
	      break;
	    }
	 if (c == 1) {
	   if (callback!=null)
	     callback.transformChanged( PickingCallback.NO_PICK, null );
         }
	 else {
          canvas.setCursor(SceneViewer3D.move_cursor);
	  translate.setTransformGroup(specialGroup);//Wegen Reset!
 	  translate.wakeup();
	 }
      }
    }
  }
   
  /**
    * Callback method from MouseTranslate
    * This is used when the Picking callback is enabled
    */
  public void transformChanged( int type, Transform3D transform ) {
      callback.transformChanged( PickingCallback.TRANSLATE, currentTG );
  }

  /**
    * Register the class @param callback to be called each
    * time the picked object moves
    */
  public void setupCallback( PickingCallback callback ) {
      this.callback = callback;
      if (callback==null)
          translate.setupCallback( null );
      else
          translate.setupCallback( this );
  }

}

