//MouseZoom mit Cursoraenderung
//UEBERWACHT ALLE MAUSEVENTS! INSB. RELEASE
//Version D

import com.sun.j3d.utils.behaviors.mouse.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;
 
public class ViewZoom extends MouseZoom {

  private Canvas3D canvas;

  public ViewZoom(TransformGroup transformGroup, Canvas3D canvas) {
   super(transformGroup);
   this.canvas = canvas;
   setFactor(-0.04);
  }

  public ViewZoom(Canvas3D canvas){
    super();
    this.canvas = canvas;
    setFactor(-0.04);
  }
   
  public ViewZoom(int flags, Canvas3D canvas) {
    super(flags);
    this.canvas = canvas;
    setFactor(-0.04);
  }
   
  //NEU: Ueberschreibe Methode aus MouseBehavior
  public void processMouseEvent(MouseEvent evt) {
    if (evt.getID()==MouseEvent.MOUSE_PRESSED) {
      if (evt.isAltDown() && !evt.isMetaDown())
        canvas.setCursor(SceneViewer3D.zoom_cursor);
       
      buttonPress = true;
      return;
    }
    else if (evt.getID()==MouseEvent.MOUSE_RELEASED){
      canvas.setCursor(SceneViewer3D.default_cursor);//Notwendig, da das hier Behavior ist!!!!!!
      buttonPress = false;
      wakeUp = false;
    }
  }
}

